package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.combat.ShipAPI;

public class GDLM_ComplexFlurry extends BaseHullMod {
	private static final float CR_RECOVERY_BONUS = 10f;
	private static final float HEALTH_BONUS = 10f;

	@Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, java.lang.String id) {
		stats.getBaseCRRecoveryRatePercentPerDay().modifyPercent(id, CR_RECOVERY_BONUS);

		stats.getEngineHealthBonus().modifyPercent(id, HEALTH_BONUS);
		stats.getWeaponHealthBonus().modifyPercent(id, HEALTH_BONUS);
	}

	@Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) return (int) CR_RECOVERY_BONUS + "%";
		if (index == 1) return (int) HEALTH_BONUS + "%";
		return null;
	}

	@Override
	public boolean isApplicableToShip(ShipAPI ship) {
		return ship != null && ship.getHullSpec().getHullId().startsWith("GL_");
	}

	@Override
	public String getUnapplicableReason(ShipAPI ship) {
		if (!ship.getHullSpec().getHullId().startsWith("GL_")) {
			return "只能安装在古达兰慕的舰船上";
		}
		return null;
	}

}
