package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;

public class GDLM_ExperimentalHull extends BaseHullMod {
	public final static float ACCURATY_BONUS = 25f;
	public final static float BALLISTIC_WEAPON_RATE_DECREASE = 20f;
	public final static float MAX_SPEED_DECREASE = 15f;
	public final static float ARMOR_DECREASE = 10f;

	@Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
		float recoilDecrease = 100f / (1f + ACCURATY_BONUS);
		stats.getRecoilPerShotMult().modifyPercent(id, recoilDecrease);
		stats.getBallisticRoFMult().modifyPercent(id, BALLISTIC_WEAPON_RATE_DECREASE);
		stats.getMaxSpeed().modifyPercent(id, -MAX_SPEED_DECREASE);
		stats.getArmorBonus().modifyPercent(id, -ARMOR_DECREASE);
	}

	@Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) return "" + ACCURATY_BONUS + "%";
		if (index == 1) return "" + BALLISTIC_WEAPON_RATE_DECREASE + "%";
		if (index == 2) return "" + MAX_SPEED_DECREASE + "%";
		if (index == 3) return "" + ARMOR_DECREASE + "%";

		return null;
	}

}
