package data.hullmods;

import com.fs.starfarer.api.combat.*;
import org.lazywizard.lazylib.combat.AIUtils;

import java.util.List;

public class GDLM_Eyes extends BaseHullMod {
	public final static String ID = "GDLM_Eyes";
	public final static float RATE_BONUS = 5f;
	public final static float INCREASE_VELOCITY = 0.5f;

	@Override
	public void advanceInCombat(ShipAPI ship, float amount) {
		MutableShipStatsAPI stats = ship.getMutableStats();
		ShipAPI target = ship.getShipTarget();
		float bonusNow;
		if (stats.getBallisticWeaponRangeBonus().getPercentBonus(ID) == null) {
			bonusNow = 0f;
		} else {
			bonusNow = stats.getBallisticWeaponRangeBonus().getPercentBonus(ID).value;
		}
		List<WeaponAPI> weapons = ship.getAllWeapons();
		if (target != null && !AIUtils.getAlliesOnMap((CombatEntityAPI) ship).contains(target)) {
			stats.getBallisticWeaponRangeBonus().modifyPercent(ID, Math.min(RATE_BONUS, bonusNow + RATE_BONUS / INCREASE_VELOCITY * amount));
			stats.getEnergyWeaponRangeBonus().modifyPercent(ID, Math.min(RATE_BONUS, bonusNow + RATE_BONUS / INCREASE_VELOCITY * amount));
		} else {
			stats.getBallisticWeaponRangeBonus().modifyPercent(ID, Math.max(0f, bonusNow - RATE_BONUS / INCREASE_VELOCITY * amount));
			stats.getEnergyWeaponRangeBonus().modifyPercent(ID, Math.max(0f, bonusNow - RATE_BONUS / INCREASE_VELOCITY * amount));
		}
		for (WeaponAPI weapon : weapons) {
			if (weapon.getId().startsWith("GL_eyes")) {
				if (weapon.getAnimation() != null) {
					weapon.getAnimation().setFrameRate(0f);
					weapon.getAnimation().setFrame(1);
					weapon.getAnimation().setAlphaMult(bonusNow / RATE_BONUS);
				}
			}
		}
	}
}