package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.combat.WeaponAPI;
import com.fs.starfarer.api.combat.WeaponAPI.WeaponSize;
import com.fs.starfarer.api.combat.WeaponAPI.WeaponType;

import java.util.List;

public class GDLM_Flux extends BaseHullMod {
	public static final float FLUX_L = 15f;
	public static final float FLUX_M = 5f;
	public static final float FLUX_S = 2f;
	public static final float DAMAGE = 75f;

	@Override
	public void applyEffectsAfterShipCreation(ShipAPI ship, java.lang.String id) {
		MutableShipStatsAPI stats = ship.getMutableStats();
		int L = 0;
		int M = 0;
		int S = 0;
		float PLUS = 0;
		List<WeaponAPI> weapons = ship.getAllWeapons();
		for (WeaponAPI weapon : weapons) {
			if (weapon.getType() != WeaponType.MISSILE) {
				if (weapon.getSize() == WeaponSize.LARGE) {
					L += 1;
				} else if (weapon.getSize() == WeaponSize.MEDIUM) {
					M += 1;
				} else if (weapon.getSize() == WeaponSize.SMALL) {
					S += 1;
				}
			}
		}
		PLUS = L * 15 + M * 5 + S * 2;
		stats.getFluxDissipation().modifyFlat(id, PLUS);
		stats.getWeaponHealthBonus().modifyMult(id, 1f / (1f + DAMAGE * 0.01f));
	}

	@Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) return "" + FLUX_L + "";
		if (index == 1) return "" + FLUX_M + "";
		if (index == 2) return "" + FLUX_S + "";
		if (index == 3) return "" + DAMAGE + "%";
		return null;
	}
}
