package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.fleet.FleetMemberAPI;

import java.util.List;

public class GDLM_MaintainProbe extends BaseHullMod {
	public static final float REPAIR_CR_SPEED = 15f;
	private static final String ID = "GDLM_MaintainProbe";

	@Override
	public void advanceInCampaign(FleetMemberAPI member, float amount) {
		if (member.getFleetData() == null) return;
		if (member.getFleetData().getFleet() == null) return;

		int MODDED_SHIP_NUM = 0;
		List<FleetMemberAPI> members = member.getFleetData().getMembersListCopy();
		for (FleetMemberAPI fmember : members) {
			if (fmember.getVariant().getHullMods().contains(ID)) {
				MODDED_SHIP_NUM += 1;
			}
		}

		for (FleetMemberAPI fmember : members) {
			MutableShipStatsAPI statsm = fmember.getStats();
			if (!fmember.isFighterWing()) {
				if (MODDED_SHIP_NUM <= 1) {
					statsm.getBaseCRRecoveryRatePercentPerDay().modifyPercent(ID, REPAIR_CR_SPEED);
				} else {
					statsm.getBaseCRRecoveryRatePercentPerDay().modifyPercent(ID, REPAIR_CR_SPEED * 2f);
				}
			}
		}
	}

	@Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) return "" + REPAIR_CR_SPEED + "%";
		if (index == 1) return "" + "30" + "%";
		return null;
	}
}
