package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;

public class GDLM_RangeStrike extends BaseHullMod {
	private static final float WEAPON_RANGE_BONUS = 100f;
	private static final float VELOCITY_DECREASE = 10f;

	@Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, java.lang.String id) {
		stats.getEnergyWeaponRangeBonus().modifyFlat(id, WEAPON_RANGE_BONUS);
		stats.getBallisticWeaponRangeBonus().modifyFlat(id, WEAPON_RANGE_BONUS);
		stats.getBeamWeaponRangeBonus().modifyFlat(id, -WEAPON_RANGE_BONUS);

		stats.getAcceleration().modifyPercent(id, -VELOCITY_DECREASE);
		stats.getDeceleration().modifyPercent(id, -VELOCITY_DECREASE);
		stats.getMaxTurnRate().modifyPercent(id, -VELOCITY_DECREASE);
		stats.getTurnAcceleration().modifyPercent(id, -VELOCITY_DECREASE);
	}

	@Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) return (int) WEAPON_RANGE_BONUS + "";
		if (index == 1) return (int) VELOCITY_DECREASE + "%";
		return null;
	}

	@Override
	public boolean isApplicableToShip(ShipAPI ship) {
		return ship != null && ship.getHullSpec().getHullId().startsWith("GL_");
	}

	@Override
	public String getUnapplicableReason(ShipAPI ship) {
		if (!ship.getHullSpec().getHullId().startsWith("GL_")) {
			return "只能安装在古达兰慕的舰船上";
		}
		return null;
	}

}
