package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.combat.WeaponAPI;
import com.fs.starfarer.api.combat.WeaponAPI.WeaponSize;
import com.fs.starfarer.api.combat.WeaponAPI.WeaponType;

import java.util.List;

//import com.fs.starfarer.api.combat.MutableShipStatsAPI;

public class GDLM_RateDecrease extends BaseHullMod {

	public static final float RATE_DECREASE = 25f;

	/*
	@Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
	    
	    stats.getBallisticWeaponRofMult().modifyPercent(id, RATE_DECREASE);
	    
	}
	*/
	@Override
	public void advanceInCombat(ShipAPI ship, float amount) {
		float effectValue = 1f / (1f - RATE_DECREASE * 0.01f) - 1f;

		List<WeaponAPI> weapons = ship.getAllWeapons();
		for (WeaponAPI weapon : weapons) {

			if (weapon.getSize() == WeaponSize.MEDIUM && weapon.getType() == WeaponType.BALLISTIC && weapon.getCooldownRemaining() >= weapon.getCooldown() * amount) {

				weapon.setRemainingCooldownTo(Math.min(weapon.getCooldown(), weapon.getCooldownRemaining() + weapon.getCooldown() * amount * effectValue));

			}
		}

	}

	@Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) return "" + (int) RATE_DECREASE + "%";
		return null;
	}

}
