package data.hullmods;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.combat.ArmorGridAPI;
import com.fs.starfarer.api.combat.FluxTrackerAPI;

import java.util.*;

public class gdlmArmor extends BaseHullMod {

	private static final String id = "gdlmarmor";
	private final Random rand = new Random();
	private static Map MaxArmor = new HashMap();
	private static Map Armornum = new HashMap();
	private static Map ArmorTime = new HashMap();

	static {
		MaxArmor.put(HullSize.FRIGATE, 0.5f);
		MaxArmor.put(HullSize.DESTROYER, 0.45f);
		MaxArmor.put(HullSize.CRUISER, 0.35f);
		MaxArmor.put(HullSize.CAPITAL_SHIP, 0.25f);
		Armornum.put(HullSize.FRIGATE, 2f);
		Armornum.put(HullSize.DESTROYER, 3f);
		Armornum.put(HullSize.CRUISER, 4f);
		Armornum.put(HullSize.CAPITAL_SHIP, 5f);
		ArmorTime.put(HullSize.FRIGATE, 3f);
		ArmorTime.put(HullSize.DESTROYER, 4f);
		ArmorTime.put(HullSize.CRUISER, 5f);
		ArmorTime.put(HullSize.CAPITAL_SHIP, 6f);
	}

	@Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) return "10%";
		if (index == 1) return "3/4/5/6";
		if (index == 2) return "10%";
		if (index == 3) return "2/3/4/5";
		if (index == 4) return "50%/45%/35%/25%";
		if (index == 5) return "15%";
		return null;
	}

	public final static class gdlm_ArmorPluginData {
		public float hp;
		public float regenTimer;
		public float repairTimer;

		public gdlm_ArmorPluginData(ShipAPI ship) {
			hp = ship.getMaxHitpoints();
			regenTimer = 0f;
			repairTimer = 0f;
		}
	}

	private float getArmorState(ShipAPI ship) {
		ArmorGridAPI armorGrid = ship.getArmorGrid();
		Random rng = new Random();
		float armorState = 0;
		int gridWidth = armorGrid.getGrid().length;
		int gridHeight = armorGrid.getGrid()[0].length;
		int candidates = 1 + (gridWidth * gridHeight) / 5;
		for (int i = 0; i < candidates; ++i) {
			int x = rng.nextInt(gridWidth);
			int y = rng.nextInt(gridHeight);
			armorState += armorGrid.getArmorFraction(x, y);
		}
		armorState /= candidates;
		return armorState;
	}

	@Override
	public void advanceInCombat(ShipAPI ship, float amount) {
		CombatEngineAPI engine = Global.getCombatEngine();
		if (!engine.getCustomData().containsKey(id)) {
			engine.getCustomData().put(id, new HashMap());
		}
		Map<ShipAPI, gdlm_ArmorPluginData> shipsMap = (Map) engine.getCustomData().get(id);
		if (engine.isPaused() || !engine.isEntityInPlay(ship) || !ship.isAlive()) {
			if (!ship.isAlive() && shipsMap.containsKey(ship)) {
				shipsMap.remove(ship);
			}
			return;
		}
		if (!shipsMap.containsKey(ship)) {
			shipsMap.put(ship, new gdlm_ArmorPluginData(ship));
		} else {
			gdlm_ArmorPluginData data = (gdlm_ArmorPluginData) shipsMap.get(ship);
			MutableShipStatsAPI stats = ship.getMutableStats();
			FluxTrackerAPI flux = ship.getFluxTracker();
			if (data.hp - ship.getHitpoints() <= ship.getMaxHitpoints() * 0.1f) {//将现有结构和缓存中的结构数值对比，如果结构收到的伤害比十分之一结构小
				data.regenTimer += amount;//则持续增加*无伤时间*
				//engine.maintainStatusForPlayerShip("2", "graphics/icons/blackhole.png", "结构没有损失", "缓存的结构" + data.hp, false);
			} else {//如果结构收到的伤害比十分之一结构大
				data.hp = ship.getHitpoints();//更新缓存中的结构数值
				data.regenTimer = 0f;//*无伤时间*归零
			}
			if (!flux.isOverloaded() && !flux.isVenting()) {//假设这艘船没有过载或者耗散
				HullSize hullSize = ship.getHullSize();
				float armorState = getArmorState(ship);
				//engine.maintainStatusForPlayerShip("3", "graphics/icons/blackhole.png", "可能正在修复", "无伤时间是" + data.regenTimer, false);
				if (data.regenTimer >= (Float) (ArmorTime.get(hullSize))) {//如果*无伤时间*达到了最少的时间要求
					data.hp = ship.getHitpoints();//则更新缓存
					data.regenTimer = 0f;//并且重新计算*无伤时间*
					if (armorState < (Float) (MaxArmor.get(hullSize))) {
						data.repairTimer = 1f;//如果需要修甲，则修甲至少1秒
					}
				}
				if (data.repairTimer > 0f) {
					ship.getMutableStats().getArmorDamageTakenMult().modifyPercent("gdlmarmor", 15f);
					if (engine.getPlayerShip() == ship) {
						//engine.maintainStatusForPlayerShip("gdlmarmorinfo1", "graphics/icons/blackhole.png", "纳米重构无人机", "正在维修装甲", false);
					}
					ArmorGridAPI armorGrid = ship.getArmorGrid();
					int x = rand.nextInt(armorGrid.getGrid().length);
					int y = rand.nextInt(armorGrid.getGrid()[0].length);
					float newArmor = armorGrid.getArmorValue(x, y);
					float cellSize = armorGrid.getCellSize();
					if (Float.compare(newArmor, armorGrid.getMaxArmorInCell()) < 0) {
						newArmor += (Float) (Armornum.get(hullSize)) * amount;
						armorGrid.setArmorValue(x, y, Math.min(armorGrid.getMaxArmorInCell(), newArmor));
					}
					data.repairTimer -= amount;
				} else {//假设不修甲
					//engine.maintainStatusForPlayerShip("4", "graphics/icons/blackhole.png", "不在修复", "test4", false);
					ship.getMutableStats().getArmorDamageTakenMult().modifyPercent("gdlmarmor", -10f);
				}
			}
		}
	}

	@Override
	public boolean isApplicableToShip(ShipAPI ship) {
		return !(ship.getVariant().getHullMods().contains("heavyarmor"));
	}

	@Override
	public void applyEffectsAfterShipCreation(ShipAPI ship, String id) {
		if (ship.getVariant().getHullMods().contains("heavyarmor")) {
			ship.getVariant().removeMod("heavyarmor");
		}
	}

	@Override
	public String getUnapplicableReason(ShipAPI ship) {
		if (ship.getVariant().getHullMods().contains("heavyarmor")) {
			return "无法兼容重型装甲";
		}
		return null;
	}
}