package data.missions.GLSTest;

import java.util.List;

import com.fs.starfarer.api.combat.BaseEveryFrameCombatPlugin;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.fleet.FleetGoal;
import com.fs.starfarer.api.fleet.FleetMemberType;
import com.fs.starfarer.api.mission.FleetSide;
import com.fs.starfarer.api.mission.MissionDefinitionAPI;
import com.fs.starfarer.api.mission.MissionDefinitionPlugin;

public class MissionDefinition implements MissionDefinitionPlugin {

	@Override
	public void defineMission(MissionDefinitionAPI api) {

		// Set up the fleets
		api.initFleet(FleetSide.PLAYER, "Gudalamu", FleetGoal.ATTACK, false, 10);
		api.initFleet(FleetSide.ENEMY, "hegemony", FleetGoal.ATTACK, true, 10);

		// Set a blurb for each fleet
		api.setFleetTagline(FleetSide.PLAYER, "古达兰慕战术模拟器");
		api.setFleetTagline(FleetSide.ENEMY, "模拟霸主远征舰队");

		// These show up as items in the bulleted list under 
		// "Tactical Objectives" on the mission detail screen
		api.addBriefingItem("战术模拟");

		// Set up the player's fleet
		api.addToFleet(FleetSide.PLAYER, "GL_Central_Support", FleetMemberType.SHIP, "Tactical simulator", true);
		api.addToFleet(FleetSide.PLAYER, "GL_Shell_Assault", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Shell_Elite", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Revival_Air_defense", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Revival_Elite", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Arrow_Assault", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Arrow_Elite", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Annihilation_Assault", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Annihilation_Support", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Harbor_Support", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Vector_Air_rights", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Vector_Bombing", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Vector_Support", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Warrior_Support", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Spine_Support", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Blunt_standard", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Confrontation-Standard", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Mine_Elite", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Haven_Air_rights", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Haven_Elite", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Haven_Support", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Chelated_Eilte", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Shoulderpad_Assault", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Coral_Assault", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Position_Attack", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Shock_variant", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Chimney_Self_help", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Bullet_Assault", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Beetle_Support", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Beetle_BA_Support", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Telescope_Support", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Cheap_Self_help", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Stable_Strike", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Gals_variant", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Surprise_Standard", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Mine_C_Standard", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Bullet_BA_Assault", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Broad_Self_help", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Scalar_Self_help", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Trasure_Assault", FleetMemberType.SHIP, "Tactical simulator", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Anxiety_Test", FleetMemberType.SHIP, "Tactical simulator", false);

		//api.addToFleet(FleetSide.PLAYER, "onslaught_Standard", FleetMemberType.SHIP, "TTS Invincible", true, CrewXPLevel.ELITE);

		// Mark player flagship as essential

		// Set up the enemy fleet

		api.addToFleet(FleetSide.ENEMY, "onslaught_Standard", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "onslaught_Standard", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "dominator_XIV_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "dominator_XIV_Elite", FleetMemberType.SHIP, false);

		api.addToFleet(FleetSide.ENEMY, "heron_Strike", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "heron_Strike", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "heron_Strike", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "heron_Strike", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "heron_Strike", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "heron_Strike", FleetMemberType.SHIP, false);

		api.addToFleet(FleetSide.ENEMY, "eagle_xiv_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "eagle_xiv_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "eagle_xiv_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "eagle_xiv_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "eagle_xiv_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "eagle_xiv_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "eagle_xiv_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "eagle_xiv_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "eagle_xiv_Elite", FleetMemberType.SHIP, false);

		//api.addToFleet(FleetSide.ENEMY, "enforcer_Assault", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "enforcer_XIV_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "enforcer_XIV_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "enforcer_XIV_Elite", FleetMemberType.SHIP, false);

		api.addToFleet(FleetSide.ENEMY, "enforcer_XIV_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "enforcer_XIV_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "enforcer_XIV_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "enforcer_XIV_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "enforcer_XIV_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "enforcer_XIV_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "enforcer_XIV_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "enforcer_XIV_Elite", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "enforcer_XIV_Elite", FleetMemberType.SHIP, false);

		// Set up the map.
		float width = 24000f;
		float height = 18000f;
		api.initMap((float) -width / 2f, (float) width / 2f, (float) -height / 2f, (float) height / 2f);

		float minX = -width / 2;
		float minY = -height / 2;

		for (int i = 0; i < 15; i++) {
			float x = (float) Math.random() * width - width / 2;
			float y = (float) Math.random() * height - height / 2;
			float radius = 100f + (float) Math.random() * 900f;
			api.addNebula(x, y, radius);
		}
		api.setBackgroundSpriteName("graphics/backgrounds/hyperspace1.jpg");
		//api.setBackgroundSpriteName("graphics/backgrounds/background6.jpg");

		//system.setBackgroundTextureFilename("graphics/backgrounds/background6.jpg");
		//api.setBackgroundSpriteName();

		// Add an asteroid field going diagonally across the
		// battlefield, 2000 pixels wide, with a maximum of 
		// 100 asteroids in it.
		// 20-70 is the range of asteroid speeds.
		api.addAsteroidField(0f, 0f, (float) Math.random() * 360f, width, 20f, 70f, 100);

		api.addPlugin(new BaseEveryFrameCombatPlugin() {
			@Override
			public void advance(float amount, List events) {
			}

			@Override
			public void init(CombatEngineAPI engine) {
				engine.getContext().setStandoffRange(10000f);
			}
		});
	}

}






