package data.missions.Journey;

import java.util.List;

import com.fs.starfarer.api.combat.BaseEveryFrameCombatPlugin;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.fleet.FleetGoal;
import com.fs.starfarer.api.fleet.FleetMemberType;
import com.fs.starfarer.api.mission.FleetSide;
import com.fs.starfarer.api.mission.MissionDefinitionAPI;
import com.fs.starfarer.api.mission.MissionDefinitionPlugin;

public class MissionDefinition implements MissionDefinitionPlugin {

	@Override
	public void defineMission(MissionDefinitionAPI api) {

		// Set up the fleets
		api.initFleet(FleetSide.PLAYER, "GLS", FleetGoal.ATTACK, false, 10);
		api.initFleet(FleetSide.ENEMY, "HSS", FleetGoal.ATTACK, true, 10);

		// Set a blurb for each fleet
		api.setFleetTagline(FleetSide.PLAYER, "第三十六先遣舰队");
		api.setFleetTagline(FleetSide.ENEMY, "未知目标");

		// These show up as items in the bulleted list under 
		// "Tactical Objectives" on the mission detail screen
		api.addBriefingItem("尚不清楚目标的行为模式");
		api.addBriefingItem("GLS Fortress必须存活");

		// Set up the player's fleet
		api.addToFleet(FleetSide.PLAYER, "GL_Shell_Elite", FleetMemberType.SHIP, "GLS Fortress", true);
		api.addToFleet(FleetSide.PLAYER, "GL_Spine_Support", FleetMemberType.SHIP, "GLS Guys", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Spine_Support", FleetMemberType.SHIP, "GLS Rays", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Haven_Support", FleetMemberType.SHIP, "GLS space", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Haven_Support", FleetMemberType.SHIP, "GLS Duel", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Haven_Support", FleetMemberType.SHIP, "GLS Duel", false);
		api.addToFleet(FleetSide.PLAYER, "GL_Shoulderpad_Assault", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.PLAYER, "GL_Shoulderpad_Assault", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.PLAYER, "GL_Beetle_Support", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.PLAYER, "GL_Beetle_Support", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.PLAYER, "GL_Beetle_Support", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.PLAYER, "GL_Beetle_Support", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.PLAYER, "GL_Beetle_Support", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.PLAYER, "GL_Telescope_Support", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.PLAYER, "GL_Telescope_Support", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.PLAYER, "GL_Chimney_Self_help", FleetMemberType.SHIP, false);

		//api.addToFleet(FleetSide.PLAYER, "onslaught_Standard", FleetMemberType.SHIP, "TTS Invincible", true, CrewXPLevel.ELITE);

		// Mark player flagship as essential

		// Set up the enemy fleet

		api.addToFleet(FleetSide.ENEMY, "prometheus2_Standard", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "prometheus2_Standard", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "prometheus2_Standard", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "colossus2_Pather", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "colossus2_Pather", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "colossus2_Pather", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "colossus2_Pather", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "colossus2_Pather", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "enforcer_Overdriven", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "enforcer_Overdriven", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "enforcer_Overdriven", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "mule_d_Standard", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "mule_d_Standard", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "brawler_pather_Raider", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "brawler_pather_Raider", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "cerberus_Overdriven", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "cerberus_Overdriven", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "kite_luddic_path_Raider", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "kite_luddic_path_Raider", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "kite_luddic_path_Raider", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "kite_luddic_path_Raider", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "kite_luddic_path_Raider", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "kite_luddic_path_Raider", FleetMemberType.SHIP, false);

		// Set up the map.
		float width = 24000f;
		float height = 18000f;
		api.initMap((float) -width / 2f, (float) width / 2f, (float) -height / 2f, (float) height / 2f);

		float minX = -width / 2;
		float minY = -height / 2;

		for (int i = 0; i < 15; i++) {
			float x = (float) Math.random() * width - width / 2;
			float y = (float) Math.random() * height - height / 2;
			float radius = 100f + (float) Math.random() * 900f;
			api.addNebula(x, y, radius);
		}
		api.setBackgroundSpriteName("graphics/backgrounds/hyperspace1.jpg");
		//api.setBackgroundSpriteName("graphics/backgrounds/background6.jpg");

		//system.setBackgroundTextureFilename("graphics/backgrounds/background6.jpg");
		//api.setBackgroundSpriteName();

		// Add an asteroid field going diagonally across the
		// battlefield, 2000 pixels wide, with a maximum of 
		// 100 asteroids in it.
		// 20-70 is the range of asteroid speeds.
		api.addAsteroidField(0f, 0f, (float) Math.random() * 360f, width, 20f, 70f, 100);

		api.addPlugin(new BaseEveryFrameCombatPlugin() {
			@Override
			public void advance(float amount, List events) {
			}

			@Override
			public void init(CombatEngineAPI engine) {
				engine.getContext().setStandoffRange(10000f);
			}
		});
	}

}






