package data.scripts;

import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.impl.combat.BaseShipSystemScript;

public class AccurateTargetStats extends BaseShipSystemScript {
	public static final float DAMAGE_BONUS_PERCENT = 25f;
	public static final float RANGE_BONUS = 20f;
	//public static final float RATE_DOWN_PERCENT = 50f;

	@Override
	public void apply(MutableShipStatsAPI stats, String id, State state, float effectLevel) {
		float bonusPercent = DAMAGE_BONUS_PERCENT * effectLevel;
		float bonusPercent1 = 100f / (100f + DAMAGE_BONUS_PERCENT) * effectLevel;
		float bonusPercent2 = RANGE_BONUS * effectLevel;
		float bonusPercent3 = -RANGE_BONUS * effectLevel;
		//float bonusPercent4 = RATE_DOWN_PERCENT * effectLevel;
		stats.getEnergyWeaponDamageMult().modifyPercent(id, bonusPercent);
		stats.getBallisticWeaponDamageMult().modifyPercent(id, bonusPercent);
		stats.getBeamWeaponDamageMult().modifyMult(id, bonusPercent1);
		stats.getEnergyWeaponRangeBonus().modifyPercent(id, bonusPercent2);
		stats.getBallisticWeaponRangeBonus().modifyPercent(id, bonusPercent2);
		stats.getBeamWeaponRangeBonus().modifyPercent(id, bonusPercent3);
		//stats.getEnergyRoFMult().modifyPercent(id, bonusPercent4);
		//stats.getBallisticRoFMult().modifyPercent(id, bonusPercent4);
	}

	@Override
	public void unapply(MutableShipStatsAPI stats, String id) {
		stats.getEnergyWeaponDamageMult().unmodify(id);
		stats.getBallisticWeaponDamageMult().unmodify(id);
		stats.getBeamWeaponDamageMult().unmodify(id);
		stats.getEnergyWeaponRangeBonus().unmodify(id);
		stats.getBallisticWeaponRangeBonus().unmodify(id);
		stats.getBeamWeaponRangeBonus().unmodify(id);
		//stats.getEnergyRoFMult().unmodify(id);
		//stats.getBallisticRoFMult().unmodify(id);
	}

	@Override
	public StatusData getStatusData(int index, State state, float effectLevel) {
		float bonusPercent = DAMAGE_BONUS_PERCENT * effectLevel;
		float bonusPercent2 = RANGE_BONUS * effectLevel;
		//float bonusPercent4 = RATE_DOWN_PERCENT * effectLevel;
		if (index == 0) {
			return new StatusData("+" + (int) bonusPercent + "% 实弹、能量武器伤害", false);
		}
		if (index == 1) {
			return new StatusData("+" + (int) bonusPercent2 + "% 实弹、能量武器射程", false);
		}
		//if (index == 2) {
		//return new StatusData("-" + (int) bonusPercent4 + "% 实弹、能量武器射速" , false);
		//}
		return null;
	}
}