package data.scripts;

import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.impl.combat.BaseShipSystemScript;
import com.fs.starfarer.api.plugins.ShipSystemStatsScript;

public class EnergyRamStats extends BaseShipSystemScript {

	public static final float MASS = 5800f;
	public static final float SPEED = 335f;

	@Override
	public void apply(MutableShipStatsAPI stats, String id, State state, float effectLevel) {
		ShipAPI ship = (ShipAPI) stats.getEntity();
		if (ship == null) {
			return;
		}
		if (state == ShipSystemStatsScript.State.OUT) {
			stats.getMaxSpeed().unmodify(id);
		} else {
			stats.getMaxSpeed().modifyFlat(id, SPEED * effectLevel);
			stats.getAcceleration().modifyFlat(id, 200f * effectLevel);
			stats.getHullDamageTakenMult().modifyPercent(id, -90f * effectLevel);
			stats.getArmorDamageTakenMult().modifyPercent(id, -90f * effectLevel);
			stats.getEmpDamageTakenMult().modifyPercent(id, -90f * effectLevel);
			ship.setMass(MASS + MASS * effectLevel);
		}
	}

	@Override
	public void unapply(MutableShipStatsAPI stats, String id) {
		ShipAPI ship = (ShipAPI) stats.getEntity();
		if (ship == null) {
			return;
		}
		stats.getMaxSpeed().unmodify(id);
		stats.getAcceleration().unmodify(id);
		stats.getHullDamageTakenMult().unmodify(id);
		stats.getArmorDamageTakenMult().unmodify(id);
		stats.getEmpDamageTakenMult().unmodify(id);
		ship.setMass(MASS);
	}

	@Override
	public StatusData getStatusData(int index, State state, float effectLevel) {
		if (index == 0) {
			return new StatusData("能量撞角激活中", false);
		}
		return null;
	}
}