package data.scripts;

import com.fs.starfarer.api.combat.FighterWingAPI;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.impl.combat.BaseShipSystemScript;

import java.awt.*;
import java.util.Iterator;
import java.util.List;

public class FighterFieldStats extends BaseShipSystemScript {

	public static final float DAMAGE = 50f;
	//public static final Color DAMP = new Color(255, 165, 90, 55);
	//public static final Color DAMPU = new Color(255, 165, 90, 155);

	@Override
	public void apply(MutableShipStatsAPI stats, String id, State state, float effectLevel) {

		ShipAPI ship = (ShipAPI) stats.getEntity();

		List<FighterWingAPI> wings = ship.getAllWings();
		Iterator iter = wings.iterator();
		while (iter.hasNext()) {
			FighterWingAPI wing = (FighterWingAPI) iter.next();

			List<ShipAPI> members = wing.getWingMembers();
			Iterator iter2 = members.iterator();
			while (iter2.hasNext()) {
				ShipAPI member = (ShipAPI) iter2.next();

				MutableShipStatsAPI wstats = member.getMutableStats();

				wstats.getEmpDamageTakenMult().modifyPercent(id, -DAMAGE * effectLevel);
				wstats.getHullDamageTakenMult().modifyPercent(id, -DAMAGE * effectLevel);
				wstats.getArmorDamageTakenMult().modifyPercent(id, -DAMAGE * effectLevel);
				wstats.getShieldDamageTakenMult().modifyPercent(id, -DAMAGE * effectLevel);
				member.setJitter(ship, new Color(255, 165, 90, 10), 1f * effectLevel, 2, 0f, 5f);
				member.setJitter(ship, new Color(255, 165, 90, 20), 1f * effectLevel, 25, 0f, 8f);
			}
		}
	}

	@Override
	public void unapply(MutableShipStatsAPI stats, String id) {

		ShipAPI ship = (ShipAPI) stats.getEntity();

		List<FighterWingAPI> wings = ship.getAllWings();
		Iterator iter = wings.iterator();
		while (iter.hasNext()) {
			FighterWingAPI wing = (FighterWingAPI) iter.next();

			List<ShipAPI> members = wing.getWingMembers();
			Iterator iter2 = members.iterator();
			while (iter2.hasNext()) {
				ShipAPI member = (ShipAPI) iter2.next();

				MutableShipStatsAPI wstats = member.getMutableStats();

				wstats.getEmpDamageTakenMult().unmodify(id);
				wstats.getHullDamageTakenMult().unmodify(id);
				wstats.getArmorDamageTakenMult().unmodify(id);
				wstats.getShieldDamageTakenMult().unmodify(id);

			}
		}
	}

	@Override
	public StatusData getStatusData(int index, State state, float effectLevel) {
		if (index == 0) {
			return new StatusData("Active", false);
		}
		return null;
	}
}
