package data.scripts;

import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.impl.combat.BaseShipSystemScript;

public class FluxOverloadStats extends BaseShipSystemScript {

	public static final float FLUX_DISSIPATION_PERCENT = 60f;
	public static final float ENERGY_DOWN_PERCENT = 25f;

	@Override
	public void apply(MutableShipStatsAPI stats, String id, State state, float effectLevel) {
		float bonusPercent = FLUX_DISSIPATION_PERCENT * effectLevel;
		float bonusPercent1 = ENERGY_DOWN_PERCENT * effectLevel;
		stats.getFluxDissipation().modifyMult(id, 1f + bonusPercent * 0.01f);
		stats.getEnergyWeaponDamageMult().modifyMult(id, 1f - bonusPercent1 * 0.01f);
	}

	@Override
	public void unapply(MutableShipStatsAPI stats, String id) {
		stats.getFluxDissipation().unmodify(id);
		stats.getEnergyWeaponDamageMult().unmodify(id);
	}

	@Override
	public StatusData getStatusData(int index, State state, float effectLevel) {
		float bonusPercent = FLUX_DISSIPATION_PERCENT * effectLevel;
		float bonusPercent1 = ENERGY_DOWN_PERCENT * effectLevel;
		if (index == 0) {
			return new StatusData("+" + (int) bonusPercent + "% 辐能耗散", false);
		}
		if (index == 1) {
			return new StatusData("-" + (int) bonusPercent1 + "% 能量武器伤害", false);
		}
		return null;
	}
}
