package data.scripts;

import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.impl.combat.BaseShipSystemScript;

public class GDLMAccelerateStats extends BaseShipSystemScript {
	public static final float SPEED = 100f;
	public static final float ACC = 50f;

	@Override
	public void apply(MutableShipStatsAPI stats, String id, State state, float effectLevel) {
		stats.getMaxSpeed().modifyFlat(id, SPEED * effectLevel);
		stats.getAcceleration().modifyPercent(id, ACC * effectLevel);
		stats.getDeceleration().modifyPercent(id, ACC * effectLevel);
		stats.getMaxTurnRate().modifyPercent(id, ACC * effectLevel);
		stats.getTurnAcceleration().modifyPercent(id, ACC * effectLevel);
	}

	@Override
	public void unapply(MutableShipStatsAPI stats, String id) {
		stats.getMaxSpeed().unmodify(id);
		stats.getAcceleration().unmodify(id);
		stats.getDeceleration().unmodify(id);
		stats.getMaxTurnRate().unmodify(id);
		stats.getTurnAcceleration().unmodify(id);
	}

	@Override
	public StatusData getStatusData(int index, State state, float effectLevel) {
		if (index == 0) {
			return new StatusData("速度与机动性增加", false);
		}
		return null;
	}

}

