package data.scripts;

import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.WeaponAPI;
import com.fs.starfarer.api.impl.combat.BaseShipSystemScript;

public class GDLMAutoFactoryRechargeStats extends BaseShipSystemScript {

	@Override
	public void apply(MutableShipStatsAPI stats, String id, State state, float effectLevel) {
		if (effectLevel < 1f) return;
		ShipAPI ship = (ShipAPI) stats.getEntity();
		if (ship == null) return;
		for (WeaponAPI weapon : ship.getAllWeapons()) {
			//Global.getCombatEngine().addFloatingText(Global.getCombatEngine().getPlayerShip().getLocation(), "did", 20f ,new Color(100,100,100,100),null, 0.25f, 120f);

			if (weapon.getType() != WeaponAPI.WeaponType.MISSILE || weapon.isPermanentlyDisabled()) continue;
			if (!weapon.usesAmmo()) continue;
			weapon.setAmmo(Math.min(Math.max(weapon.getAmmo() + weapon.getSpec().getBurstSize(), 0), weapon.getMaxAmmo()));
		}
	}

	@Override
	public StatusData getStatusData(int index, State state, float effectLevel) {
		return null;
	}
}
