package data.scripts;

import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShieldAPI;
import com.fs.starfarer.api.impl.combat.BaseShipSystemScript;

public class GDLMChaserModeStats extends BaseShipSystemScript {

	public static final float SHIELD_ABSORPTION = 1.4f;
	public static final float WEAPON_FLUX_DECREASE = 50f;
	public static final float MAX_SPEED = 40f;
	public static final float ACCELERATION = 30f;
	public static final float TURN_RATE = 25f;
	//public static final String ID = "chaser_mode_2";

	@Override
	public void apply(MutableShipStatsAPI stats, String id, State state, float effectLevel) {

		ShieldAPI shield = stats.getEntity().getShield();
		float absorption = shield.getFluxPerPointOfDamage();

		stats.getShieldAbsorptionMult().modifyFlat(id, -absorption + SHIELD_ABSORPTION * effectLevel);
		//stats.getEnergyWeaponFluxCostMod().modifyPercent(id, -WEAPON_FLUX_DECREASE * effectLevel);
		//stats.getBallisticWeaponFluxCostMod().modifyPercent(id, -WEAPON_FLUX_DECREASE * effectLevel);
		//stats.getMissileWeaponFluxCostMod().modifyPercent(id, -WEAPON_FLUX_DECREASE * effectLevel);
		//stats.getBeamWeaponFluxCostMult().modifyPercent(id, -WEAPON_FLUX_DECREASE * effectLevel);
		stats.getMaxSpeed().modifyPercent(id, MAX_SPEED * effectLevel);
		stats.getAcceleration().modifyPercent(id, ACCELERATION * effectLevel);
		stats.getDeceleration().modifyPercent(id, ACCELERATION * effectLevel);
		stats.getMaxTurnRate().modifyPercent(id, TURN_RATE * effectLevel);
		stats.getTurnAcceleration().modifyPercent(id, TURN_RATE * effectLevel);

	}

	@Override
	public void unapply(MutableShipStatsAPI stats, String id) {
		//stats.getShieldAbsorptionMult().unmodify(ID);
		stats.getShieldAbsorptionMult().unmodify(id);
		//stats.getEnergyWeaponFluxCostMod().unmodify(id);
		//stats.getBallisticWeaponFluxCostMod().unmodify(id);
		//stats.getMissileWeaponFluxCostMod().unmodify(id);
		//stats.getBeamWeaponFluxCostMult().unmodify(id);
		stats.getMaxSpeed().unmodify(id);
		stats.getAcceleration().unmodify(id);
		stats.getDeceleration().unmodify(id);
		stats.getMaxTurnRate().unmodify(id);
		stats.getTurnAcceleration().unmodify(id);
	}

	@Override
	public StatusData getStatusData(int index, State state, float effectLevel) {
		if (index == 0) {
			return new StatusData("追逐者模式", false);
		}
		return null;
	}
}
