package data.scripts;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShieldAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.impl.combat.BaseShipSystemScript;
import com.fs.starfarer.api.plugins.ShipSystemStatsScript;

public class GDLMGuardianShieldStats extends BaseShipSystemScript {
	/*
	瞬间开盾 盾效*0.01
	5s
	幅散*0.5
	*/
	public static final float SHIELD = 0.01f;
	public static final float FLUX = 0.5f;
	//public static final String ID = "guardian_shield";

	public void apply(MutableShipStatsAPI stats, String id, State state, float effectLevel) {
		if (state == ShipSystemStatsScript.State.OUT) {
			stats.getShieldUnfoldRateMult().unmodify(id);
			stats.getShieldDamageTakenMult().unmodify(id);
			stats.getFluxDissipation().modifyMult(id, FLUX);
		} else {
			CombatEngineAPI engine = Global.getCombatEngine();
			ShipAPI ship = (ShipAPI) stats.getEntity();
			ShieldAPI shield = ship.getShield();
			boolean time = true;
			if (effectLevel == 0f) {
				time = true;
			} else if (effectLevel != 0f) {
				if (effectLevel < 1f && time) {
					stats.getShieldUnfoldRateMult().modifyMult(id, 100000f);
					stats.getShieldDamageTakenMult().modifyMult(id, SHIELD);
					shield.toggleOn();
					if (ship == engine.getPlayerShip()) {
						engine.maintainStatusForPlayerShip("0", "graphics/icons/hullsys/fortress_shield.png", "峰值状态", "盾效倍率 " + "1%", false);
					}
				} else if (effectLevel == 1f) {
					time = false;
					stats.getShieldUnfoldRateMult().unmodify(id);
					stats.getShieldDamageTakenMult().unmodify(id);
					stats.getFluxDissipation().modifyMult(id, FLUX);
					if (ship == engine.getPlayerShip()) {
						engine.maintainStatusForPlayerShip("1", "graphics/icons/hullsys/fortress_shield.png", "缓冲状态", "幅散倍率 " + "50%", false);
					}
				}
			}
		}

	}

	public void unapply(MutableShipStatsAPI stats, String id) {
		stats.getFluxDissipation().unmodify(id);
	}

	public StatusData getStatusData(int index, State state, float effectLevel) {
		if (index == 0) {
			return new StatusData("守望者护盾", false);
		}
		return null;
	}
}
