package data.scripts;

import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.impl.combat.BaseShipSystemScript;

public class GDLMSupportModeStats extends BaseShipSystemScript {

	public static final float WEAPON_RANGE = 100f;
	public static final float WEAPON_TURN_RATE = 100f;
	public static final float MAX_SPEED = 15f;
	public static final String ID = "support_mode_2";

	@Override
	public void apply(MutableShipStatsAPI stats, String id, State state, float effectLevel) {
		stats.getBallisticWeaponRangeBonus().modifyPercent(id, WEAPON_RANGE * effectLevel);
		stats.getEnergyWeaponRangeBonus().modifyPercent(id, WEAPON_RANGE * effectLevel);
		stats.getMissileWeaponRangeBonus().modifyPercent(id, WEAPON_RANGE * effectLevel);
		stats.getBeamWeaponTurnRateBonus().modifyPercent(id, WEAPON_TURN_RATE * effectLevel);
		stats.getWeaponTurnRateBonus().modifyPercent(id, WEAPON_TURN_RATE * effectLevel);
		stats.getMaxSpeed().modifyFlat(ID, 100000f * effectLevel);
		stats.getMaxSpeed().modifyMult(id, MAX_SPEED / 100000f * effectLevel);
	}

	@Override
	public void unapply(MutableShipStatsAPI stats, String id) {
		stats.getBallisticWeaponRangeBonus().unmodify(id);
		stats.getEnergyWeaponRangeBonus().unmodify(id);
		stats.getMissileWeaponRangeBonus().unmodify(id);
		stats.getBeamWeaponTurnRateBonus().unmodify(id);
		stats.getWeaponTurnRateBonus().unmodify(id);
		stats.getMaxSpeed().unmodify(ID);
		stats.getMaxSpeed().unmodify(id);
	}

	@Override
	public StatusData getStatusData(int index, State state, float effectLevel) {
		if (index == 0) {
			return new StatusData("武器射程+100%", false);
		}
		return null;
	}
}
