package data.scripts.ai;

import com.fs.starfarer.api.combat.*;

import org.lwjgl.util.vector.Vector2f;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class GDLMAutoFactoryRechargeAI implements ShipSystemAIScript {
	private CombatEngineAPI engine;
	private ShipAPI ship;
	private static Map mag = new HashMap();

	static {
		mag.put(WeaponAPI.WeaponSize.SMALL, 1f);
		mag.put(WeaponAPI.WeaponSize.MEDIUM, 2f);
		mag.put(WeaponAPI.WeaponSize.LARGE, 4f);
	}

	@Override
	public void init(ShipAPI ship, ShipSystemAPI system, ShipwideAIFlags flags, CombatEngineAPI engine) {
		this.ship = ship;
		this.engine = engine;
	}

	@Override
	public void advance(float amount, Vector2f missileDangerDir, Vector2f collisionDangerDir, ShipAPI target) {
		float totalValue = 0f;
		float value = 0f;
		List<WeaponAPI> weapons = ship.getUsableWeapons();
		for (WeaponAPI weapon : weapons) {
			if (weapon.getType() != WeaponAPI.WeaponType.MISSILE) continue;

			totalValue += (Float) mag.get(weapon.getSize());
			if (weapon.getChargeLevel() > 0f) continue;
			value += (Float) mag.get(weapon.getSize()) * weapon.getAmmo() / weapon.getMaxAmmo();
		}
		if (value / totalValue >= 0.5f) ship.useSystem();
	}
}