package data.scripts.ai;

import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.MissileAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipSystemAIScript;
import com.fs.starfarer.api.combat.ShipSystemAPI;
import com.fs.starfarer.api.combat.ShipwideAIFlags;
import org.lwjgl.util.vector.Vector2f;
import org.lazywizard.lazylib.combat.AIUtils;

import java.util.*;

public class GDLMBurstEMPAI implements ShipSystemAIScript {
	private CombatEngineAPI engine;
	private ShipAPI ship;

	@Override
	public void init(ShipAPI ship, ShipSystemAPI system, ShipwideAIFlags flags, CombatEngineAPI engine) {
		this.ship = ship;
		this.engine = engine;
	}

	@Override
	public void advance(float amount, Vector2f missileDangerDir, Vector2f collisionDangerDir, ShipAPI target) {
		if (engine.isPaused() || !ship.isAlive()) {
			return;
		}
		List<ShipAPI> nearbyShips = AIUtils.getNearbyEnemies(ship, 600f);
		List<MissileAPI> nearbyMissiles = AIUtils.getNearbyEnemyMissiles(ship, 600f);
		if (nearbyShips.size() + nearbyMissiles.size() >= 4) {
			ship.useSystem();
		}
	}
}