//by a111164
package data.scripts.utils;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.CargoAPI;
import com.fs.starfarer.api.combat.*;
import com.fs.starfarer.api.loading.WeaponSlotAPI;
import org.lazywizard.lazylib.CollisionUtils;
import org.lazywizard.lazylib.MathUtils;
import org.lazywizard.lazylib.VectorUtils;
import org.lazywizard.lazylib.combat.AIUtils;
import org.lazywizard.lazylib.combat.CombatUtils;
import org.lwjgl.util.vector.Vector2f;

import java.awt.*;
import java.util.ArrayList;
import java.util.List;

public class GDLMTool {

	//move ship's facing
	//return time need to turn
	public static void moveToAngle(CombatEntityAPI ship, float toAngle, float amount) {
		float angleDist = 0f;
		float angleNow = ship.getFacing();
		float turnRateNow = ship.getAngularVelocity();// minus = turning to right
		float maxTurnRate = 0f;
		float accTurnRate = 0f;
		float decTurnRate = 0f;
		float trueMult = 1 / amount;

		if (ship instanceof ShipAPI) {
			maxTurnRate = ((ShipAPI) ship).getMaxTurnRate() * amount;
			accTurnRate = ((ShipAPI) ship).getTurnAcceleration() * amount;
			decTurnRate = ((ShipAPI) ship).getTurnDeceleration() * amount;

		}
		if (ship instanceof MissileAPI) {
			maxTurnRate = ((MissileAPI) ship).getMaxTurnRate() * amount;
			accTurnRate = ((MissileAPI) ship).getTurnAcceleration() * amount;
			decTurnRate = accTurnRate;
		}

		//get which side to turn and how much to turn, minus = you are in the left side
		angleDist = MathUtils.getShortestRotation(angleNow, toAngle);

		//Global.getCombatEngine().addFloatingText(getExtendedLocationFromPoint(ship.getLocation(), ship.getFacing(), 50f), turnRateNow + "turnRate", 20f ,new Color (0, 100, 200, 240),ship, 0.25f, 120f);

		boolean turnRight = false;//true == should turn right, false == should turn left
		if (angleDist < 0) {
			turnRight = true;
		} else {
			turnRight = false;
		}

		float angleDistBeforeStop = (turnRateNow / 2) * (turnRateNow / (accTurnRate * trueMult)) - 1;
		if (turnRight) {
			if (turnRateNow > 0)//want to turn right but is turning to left, turnRateNow > 0
			{

				if (turnRateNow >= decTurnRate)//stop turning left, till turnRateNow is 0
				{
					ship.setAngularVelocity(turnRateNow - decTurnRate);
				} else {
					ship.setAngularVelocity(0);
				}

				//((ShipAPI)ship).giveCommand(ShipCommand.TURN_RIGHT,null,0);
			} else//want to turn right and is turning right, turnRateNow < 0
			{

				if (Math.abs(angleDist) >= angleDistBeforeStop)//accelerate till maxTurnRate
				{
					//((ShipAPI)ship).giveCommand(ShipCommand.TURN_RIGHT,null,0);

					if (Math.abs(turnRateNow) <= (maxTurnRate * trueMult)) {
						ship.setAngularVelocity(turnRateNow - accTurnRate);
					} else {
						ship.setAngularVelocity(-maxTurnRate * trueMult);
					}

				} else {
					//((ShipAPI)ship).giveCommand(ShipCommand.TURN_LEFT,null,0);

					if (Math.abs(turnRateNow) >= decTurnRate)//decelerate till 0
					{
						ship.setAngularVelocity(turnRateNow + decTurnRate);
					} else {
						ship.setAngularVelocity(0);
					}

				}

			}
		} else//to turn left
		{
			if (turnRateNow < 0)//want to turn left but is turning to right, turnRateNow < 0
			{
				//((ShipAPI)ship).giveCommand(ShipCommand.TURN_LEFT,null,0);

				if (Math.abs(turnRateNow) >= decTurnRate)//stop turning right, till turnRateNow is 0
				{
					ship.setAngularVelocity(turnRateNow + decTurnRate);
				} else {
					ship.setAngularVelocity(0);
				}

			} else//want to turn left and is turning left, turnTateNow > 0
			{

				if (Math.abs(angleDist) > angleDistBeforeStop)//accelerate till maxTurnRate
				{
					//((ShipAPI)ship).giveCommand(ShipCommand.TURN_LEFT,null,0);
					if (turnRateNow <= maxTurnRate * trueMult) {
						ship.setAngularVelocity(turnRateNow + accTurnRate);
					} else {
						ship.setAngularVelocity(maxTurnRate * trueMult);
					}

				} else {
					//((ShipAPI)ship).giveCommand(ShipCommand.TURN_RIGHT,null,0);
					if (turnRateNow >= decTurnRate)//decelerate till 0
					{
						ship.setAngularVelocity(turnRateNow - decTurnRate);
					} else {
						ship.setAngularVelocity(0);
					}

				}
			}
		}

	}

	//rotate velocity of a ship but not facing
	public static void moveToAngle(CombatEntityAPI ship, Vector2f velocity, float toAngle, float amount) {
		float angleDist = 0f;
		float angleNow = VectorUtils.getFacing(velocity);
		float turnRateNow = 0f;
		float maxTurnRate = 0f;
		if (ship instanceof ShipAPI) {
			maxTurnRate = ((ShipAPI) ship).getMaxTurnRate() * amount;
		}
		if (ship instanceof MissileAPI) {
			maxTurnRate = ((MissileAPI) ship).getMaxTurnRate() * amount;
		}
		boolean turnRight = false;//true == should turn right, false == should turn left
		//judge how much to turn;
		if (Math.abs(angleNow - toAngle) < 360f - Math.abs(angleNow - toAngle)) {
			angleDist = Math.abs(angleNow - toAngle);

		} else {
			angleDist = 360f - Math.abs(angleNow - toAngle);

		}
		//judge which side to turn
		if (toAngle < 180f) {
			if (angleNow - toAngle < 180f && angleNow - toAngle > 0f) {
				turnRight = true;
			} else {
				turnRight = false;
			}

		} else {
			if (angleNow - toAngle >= 0f || angleNow <= toAngle - 180f) {
				turnRight = true;
			} else {
				turnRight = false;
			}
		}

		//to turn the ship
		if (angleDist > maxTurnRate) {
			if (turnRight) {
				VectorUtils.rotate(ship.getVelocity(), -maxTurnRate);
			} else {
				VectorUtils.rotate(ship.getVelocity(), maxTurnRate);
			}

		} else {

		}

	}

	//turn weapon to angle with accelerate
	public float moveToAngle(float toAngle, float MAX_SPEED, float ACC, WeaponAPI w, float turnRate, float amount) {
		float angleDist = 0f;
		float angleNow = w.getCurrAngle();
		float turnRateNow = turnRate;// minus = turning to right
		float maxTurnRate = MAX_SPEED * amount;
		float accTurnRate = ACC * amount;
		float decTurnRate = ACC * amount;
		float trueMult = 1 / amount;

		float arcAngle = w.getArcFacing();

		//get which side to turn and how much to turn, minus = you are in the left side
		if (w.getArc() >= 360) {
			angleDist = MathUtils.getShortestRotation(angleNow, toAngle);
		} else {
			// getShortest > 0 == toAngle is at right side of arcAngle
			float toAngleDist = MathUtils.getShortestRotation(arcAngle, toAngle);
			float nowAngleDist = MathUtils.getShortestRotation(arcAngle, w.getCurrAngle());
			angleDist = toAngleDist - nowAngleDist;
			//engine.addFloatingText(engine.getPlayerShip().getMouseTarget(),angleDist + "",20f,new Color(100,100,100,100),engine.getPlayerShip(),1f,2f);

		}

		//stable ship's direction if it is nearly there
		if (Math.abs(angleDist) <= maxTurnRate && Math.abs(turnRateNow) <= decTurnRate) {
			w.setCurrAngle(toAngle);
			return 0;
		}
		//Global.getCombatEngine().addFloatingText(getExtendedLocationFromPoint(ship.getLocation(), ship.getFacing(), 50f), turnRateNow + "turnRate", 20f ,new Color (0, 100, 200, 240),ship, 0.25f, 120f);

		boolean turnRight = false;//true == should turn right, false == should turn left
		if (angleDist < 0) {
			turnRight = true;
		} else {
			turnRight = false;
		}

		//engine.addFloatingText(engine.getPlayerShip().getMouseTarget(), turnRight + "",20f,new Color(100,100,100,100),engine.getPlayerShip(),1f,2f);

		float angleDistBeforeStop = (turnRateNow / 2) * (turnRateNow / (accTurnRate * trueMult));
		if (turnRight) {
			if (turnRateNow > 0)//want to turn right but is turning to left, turnRateNow > 0
			{

				if (turnRateNow >= decTurnRate)//stop turning left, till turnRateNow is 0
				{
					turnRate = (turnRateNow - decTurnRate);
				} else {
					turnRate = 0f;
				}

				//((ShipAPI)ship).giveCommand(ShipCommand.TURN_RIGHT,null,0);
			} else//want to turn right and is turning right, turnRateNow < 0
			{

				if (Math.abs(angleDist) >= angleDistBeforeStop)//accelerate till maxTurnRate
				{
					//((ShipAPI)ship).giveCommand(ShipCommand.TURN_RIGHT,null,0);

					if (Math.abs(turnRateNow) <= (maxTurnRate * trueMult)) {
						turnRate = (turnRateNow - accTurnRate);
					} else {
						turnRate = (-maxTurnRate * trueMult);
					}

				} else {
					//((ShipAPI)ship).giveCommand(ShipCommand.TURN_LEFT,null,0);

					if (Math.abs(turnRateNow) >= decTurnRate)//decelerate till 0
					{
						turnRate = (turnRateNow + decTurnRate);
					} else {
						turnRate = (0);
					}

				}

			}
		} else//to turn left
		{
			if (turnRateNow < 0)//want to turn left but is turning to right, turnRateNow < 0
			{
				//((ShipAPI)ship).giveCommand(ShipCommand.TURN_LEFT,null,0);

				if (Math.abs(turnRateNow) >= decTurnRate)//stop turning right, till turnRateNow is 0
				{
					turnRate = (turnRateNow + decTurnRate);
				} else {
					turnRate = (0);
				}

			} else//want to turn left and is turning left, turnTateNow > 0
			{

				if (Math.abs(angleDist) > angleDistBeforeStop)//accelerate till maxTurnRate
				{
					//((ShipAPI)ship).giveCommand(ShipCommand.TURN_LEFT,null,0);
					if (turnRateNow <= maxTurnRate * trueMult) {
						turnRate = (turnRateNow + accTurnRate);
					} else {
						turnRate = (maxTurnRate * trueMult);
					}

				} else {
					//((ShipAPI)ship).giveCommand(ShipCommand.TURN_RIGHT,null,0);
					if (turnRateNow >= decTurnRate)//decelerate till 0
					{
						turnRate = (turnRateNow - decTurnRate);
					} else {
						turnRate = (0);
					}

				}
			}

		}

		return turnRate;
	}

	//+ = turnLeft, - + turn right
	public static float getAngleCalculation(float originAngle, float addAngle) {
		float finalAngle = originAngle + addAngle;

		while (addAngle > 360) {
			addAngle = addAngle - 360;
		}

		while (addAngle < -360) {
			addAngle = addAngle + 360;
		}

		if (finalAngle > 360f) {
			return finalAngle - 360f;
		}
		if (finalAngle < 0f) {
			return 360f + finalAngle;
		}
		return finalAngle;

	}

	public static float getTimeNeedToTurn(float angle, float toAngle, float turnRate, float acc, float dec, float maxTurnRate) {
		float time = 0f;
		float dist = 0f;

		//no acc is invalid
		if (acc <= 0f) {
			return 999f;
		}

		//get which side to turn and how much to turn, minus = you are in the left side
		//turn rate > = 0 means turing to left
		dist = MathUtils.getShortestRotation(angle, toAngle);

		boolean sameSide = true;
		if (dist > 0 && turnRate < 0) {
			sameSide = false;
		}
		if (dist < 0 && turnRate > 0) {
			sameSide = false;
		}
		if (sameSide = true) {
			time = time + Math.abs(turnRate / dec);
			turnRate = 0f;
			dist = dist - (turnRate / 2) * Math.abs(turnRate / dec);
		}

		while (Math.abs(dist) > 1f && turnRate > 1f) {

			//stop turning to the other side first
			if (!sameSide) {
				time = time + Math.abs(turnRate / dec);
				turnRate = 0f;
				dist = dist - (turnRate / 2) * Math.abs(turnRate / dec);
			} else {
				//if we are here, we stopped turning opposite
				//if we already turning to fast and should slow down from now, do this method again when we reach target angle
				if (Math.abs(dist) <= (turnRate / 2) * Math.abs(turnRate / dec)) {

					float delta = (float) Math.sqrt(turnRate * turnRate - 2 * acc * dist);
					float resolve1 = (-turnRate + delta) / (-acc);
					float resolve2 = (-turnRate - delta) / (-acc);
					if (resolve1 > resolve2) {
						return time + resolve2;
					}
					return time + resolve1;

				}

				//if we can acc to max speed before dec
				float distToSlow = (maxTurnRate / 2) * (maxTurnRate / acc);
				if (distToSlow <= Math.abs(dist)) {
					time = time + 2 * (maxTurnRate / acc);
					dist = Math.abs(dist) - distToSlow;
					return time + dist / maxTurnRate;
				}

				//now the only situation is we acc first and dec before reach max turn speed
				dist = Math.abs(dist);
				return time + (2 * dist - turnRate * turnRate) / turnRate + turnRate / acc;

			}

		}

		return 0f;
	}

	//fly towards position, will not strafe, only turn
	//ship will stop, missile will not
	public static void moveToPosition(CombatEntityAPI entity, Vector2f toPosition, float amount) {

		if (entity instanceof ShipAPI) {
			ShipAPI ship = (ShipAPI) entity;
			Vector2f directionVec = VectorUtils.getDirectionalVector(entity.getLocation(), toPosition);
			float directionAngle = VectorUtils.getFacing(directionVec);
			float dist = MathUtils.getDistanceSquared(entity.getLocation(), toPosition);
			float timeToSlowDown = Velocity2Speed(entity.getVelocity()).y / ship.getDeceleration();//time to slow down to zero speed(by seconds,squared)				s
			float aimAngle = MathUtils.getShortestRotation(entity.getFacing(), directionAngle);
			float maxStopAngle = (ship.getMaxTurnRate() / ship.getTurnAcceleration()) * (ship.getMaxTurnRate() / 2);

			if (aimAngle > maxStopAngle) {
				ship.giveCommand(ShipCommand.TURN_LEFT, null, 0);
				ship.giveCommand(ShipCommand.DECELERATE, null, 0);
			}

			if (aimAngle < -maxStopAngle) {
				ship.giveCommand(ShipCommand.TURN_RIGHT, null, 0);
				ship.giveCommand(ShipCommand.DECELERATE, null, 0);
			}

			if (dist <= (Velocity2Speed(ship.getVelocity()).y * timeToSlowDown) + 10) {
				ship.giveCommand(ShipCommand.DECELERATE, null, 0);
			}

			if (Math.abs(aimAngle) <= maxStopAngle) {
				moveToAngle(ship, directionAngle, amount);
				ship.giveCommand(ShipCommand.ACCELERATE, null, 0);
			}

		}

		if (entity instanceof MissileAPI) {
			MissileAPI ship = (MissileAPI) entity;
			Vector2f directionVec = VectorUtils.getDirectionalVector(entity.getLocation(), toPosition);
			float directionAngle = VectorUtils.getFacing(directionVec);
			float dist = MathUtils.getDistanceSquared(entity.getLocation(), toPosition);
			float aimAngle = MathUtils.getShortestRotation(entity.getFacing(), directionAngle);
			float maxStopAngle = (ship.getMaxTurnRate() / ship.getTurnAcceleration()) * (ship.getMaxTurnRate() / 2);

			//aim angle > 0 = need to turn left,you are on the right side
			if (aimAngle > maxStopAngle) {
				ship.giveCommand(ShipCommand.TURN_LEFT);
			}

			if (aimAngle < -maxStopAngle) {
				ship.giveCommand(ShipCommand.TURN_RIGHT);
			}

			if (Math.abs(aimAngle) <= maxStopAngle) {
				moveToAngle(ship, directionAngle, amount);
				ship.giveCommand(ShipCommand.ACCELERATE);
			}
		}

	}

	// move to position but not change facing
	public static void setToPosition(ShipAPI ship, Vector2f toPosition, float amount) {
		Vector2f directionVec = VectorUtils.getDirectionalVector(ship.getLocation(), toPosition);
		float directionAngle = VectorUtils.getFacing(directionVec);
		float acceleration = ship.getAcceleration() * amount;
		float xAxis = (float) Math.cos(Math.toRadians(directionAngle)) * acceleration;
		float yAxis = (float) Math.sin(Math.toRadians(directionAngle)) * acceleration;

		float dist = MathUtils.getDistance(ship.getLocation(), toPosition);
		float timeToSlowDown = Velocity2Speed(ship.getVelocity()).y / ship.getDeceleration();
		float speedNow = Velocity2Speed(ship.getVelocity()).y;
		if (speedNow > ship.getMaxSpeed() || dist <= (Velocity2Speed(ship.getVelocity()).y * timeToSlowDown) + 2) {
			ship.giveCommand(ShipCommand.DECELERATE, null, 0);

		} else {
			//ship.giveCommand(ShipCommand.ACCELERATE, null, 0);
			moveToAngle(ship, ship.getVelocity(), directionAngle, amount);
			float X = ship.getVelocity().getX();
			float Y = ship.getVelocity().getY();
			ship.getVelocity().setX(X + xAxis);
			ship.getVelocity().setY(Y + yAxis);
		}
	}

	// move to position at a speed , will not slow down and stop at that position
	public static void forceSetToPosition(ShipAPI ship, Vector2f toPosition, float speed, float deceleration, float amount) {
		Vector2f directionVec = VectorUtils.getDirectionalVector(ship.getLocation(), toPosition);
		float directionAngle = VectorUtils.getFacing(directionVec);
		float acceleration = speed * amount;
		float dec = deceleration * amount;
		float xAxis = (float) Math.cos(Math.toRadians(directionAngle));
		float yAxis = (float) Math.sin(Math.toRadians(directionAngle));
		float speedNow = Velocity2Speed(ship.getVelocity()).y;

		float X = ship.getVelocity().getX();
		float Y = ship.getVelocity().getY();

		if (speedNow > speed) {
			moveToAngle(ship, ship.getVelocity(), directionAngle, amount);
			ship.getVelocity().setX(X - xAxis * dec);
			ship.getVelocity().setY(Y - yAxis * dec);
		} else {
			moveToAngle(ship, ship.getVelocity(), directionAngle, amount);
			ship.getVelocity().setX(X + xAxis * acceleration);
			ship.getVelocity().setY(Y + yAxis * acceleration);
		}

	}

	//vector2f(angle, speed)
	public static Vector2f Velocity2Speed(Vector2f velocity) {

		float x = (float) VectorUtils.getFacing(velocity);
		float y = (float) Math.sqrt((double) (velocity.getX() * velocity.getX() + velocity.getY() * velocity.getY()));
		return new Vector2f(x, y);
	}

	public static Vector2f Speed2Velocity(float angle, float speed) {

		float xAxis = (float) Math.cos(Math.toRadians(angle)) * speed;
		float yAxis = (float) Math.sin(Math.toRadians(angle)) * speed;
		return (new Vector2f(xAxis, yAxis));
	}

	public static Vector2f Speed2Velocity(Vector2f angleAndSpeed) {
		float angle = angleAndSpeed.x;
		float speed = angleAndSpeed.y;
		float xAxis = (float) Math.cos(Math.toRadians(angle)) * speed;
		float yAxis = (float) Math.sin(Math.toRadians(angle)) * speed;
		return (new Vector2f(xAxis, yAxis));
	}

	public static Vector2f Facing2Vector(float facing) {
		float xAxis = (float) Math.cos(Math.toRadians(facing));
		float yAxis = (float) Math.sin(Math.toRadians(facing));
		return new Vector2f(xAxis, yAxis);
	}

	public static Vector2f getDistVector(Vector2f from, Vector2f to) {
		float X = to.getX() - from.getX();
		float Y = to.getY() - from.getY();
		return new Vector2f(X, Y);

	}

	public static Vector2f getExtendedLocationFromPoint(Vector2f point, float facing, float dist) {
		float xAxis = (float) Math.cos(Math.toRadians(facing)) * dist;
		float yAxis = (float) Math.sin(Math.toRadians(facing)) * dist;
		return new Vector2f(point.getX() + xAxis, point.getY() + yAxis);
	}

	public static Vector2f getLocationTurnedRightByDegrees(Vector2f originPosition, Vector2f turnAroundWhere, float degrees) {
		float angle = VectorUtils.getAngle(turnAroundWhere, originPosition);
		float dist = MathUtils.getDistance(turnAroundWhere, originPosition);

		angle = angle + degrees;
		if (angle > 365) {
			angle = angle - 365f;
		}

		return getExtendedLocationFromPoint(turnAroundWhere, angle, dist);
	}

	public static Vector2f getDegreesTurnedRightByLocation(Vector2f originPosition, Vector2f turnAroundWhere, float angleToTurn) {
		float angle = VectorUtils.getAngle(turnAroundWhere, originPosition);
		float dist = MathUtils.getDistance(turnAroundWhere, originPosition);

		return getExtendedLocationFromPoint(turnAroundWhere, GDLMTool.getAngleCalculation(angle, angleToTurn), dist);
	}

	public static float getTargetWidthAngleInDistance(Vector2f from, CombatEntityAPI target) {
		return 2 * 57.3f //57.3 is to convert from rad to degrees
				* (float) Math.asin((double) (target.getCollisionRadius() / MathUtils.getDistance(from, target.getLocation())));//drone width by degrees
	}

	public static float getTargetWidthAngleInDistance(Vector2f from, Vector2f targetLocation, float targetRadius) {
		if (targetRadius >= MathUtils.getDistance(from, targetLocation)) {
			return 0;
		}

		return 2 * 57.3f //57.3 is to convert from rad to degrees
				* (float) Math.asin((double) (targetRadius / MathUtils.getDistance(from, targetLocation)));//drone width by degrees
	}

	public static ShipAPI isFriendlyInLine(WeaponAPI from) {
		float weaponRange = from.getRange();
		float weaponFacing = from.getCurrAngle();
		List<CombatEntityAPI> allShipsInArc = new ArrayList();
		List<CombatEntityAPI> allShips = CombatUtils.getEntitiesWithinRange(from.getSlot().computePosition(from.getShip()), weaponRange);
		//return false if there is no ship around
		if (allShips == null) {
			return null;
		}
		for (CombatEntityAPI s : allShips) {

			float targetFacing = VectorUtils.getAngle(from.getSlot().computePosition(from.getShip()), s.getLocation());
			float targetWidth = getTargetWidthAngleInDistance(from.getSlot().computePosition(from.getShip()), s);
			if (Math.abs(MathUtils.getShortestRotation(weaponFacing, targetFacing)) < targetWidth / 2 && s instanceof ShipAPI && !((ShipAPI) s).isFighter()) {
				//Global.getCombatEngine().addFloatingText(s.getLocation(),MathUtils.getShortestRotation(weaponFacing , targetFacing) + "", 20f ,new Color(100,100,100,100),s, 0.25f, 120f);
				allShipsInArc.add(s);
			}
		}

		float closestDist = 4000f;
		CombatEntityAPI closestShip = null;
		for (CombatEntityAPI c : allShipsInArc) {
			if (MathUtils.getDistance(c, from.getShip()) < closestDist) {
				closestDist = MathUtils.getDistance(c, from.getShip());
				closestShip = c;
			}
		}

		if (closestShip == null) {
			return null;
		}
		ShipAPI ship = (ShipAPI) closestShip;
		if (ship.isAlly() || ship.getOwner() == 0) {
			return ship;
		} else {
			return null;
		}
	}

	public static ShipAPI isEnemyInRange(WeaponAPI from) {
		float weaponRange = from.getRange();
		float weaponFacing = from.getCurrAngle();
		List<CombatEntityAPI> allShipsInArc = new ArrayList();
		List<CombatEntityAPI> allShips = CombatUtils.getEntitiesWithinRange(from.getSlot().computePosition(from.getShip()), weaponRange);
		//return false if there is no ship around
		if (allShips == null) {
			return null;
		}
		for (CombatEntityAPI s : allShips) {

			float targetFacing = VectorUtils.getAngle(from.getSlot().computePosition(from.getShip()), s.getLocation());
			float targetWidth = getTargetWidthAngleInDistance(from.getSlot().computePosition(from.getShip()), s);
			if (Math.abs(MathUtils.getShortestRotation(weaponFacing, targetFacing)) < targetWidth / 2 && s instanceof ShipAPI && !((ShipAPI) s).isFighter()) {
				//Global.getCombatEngine().addFloatingText(s.getLocation(),MathUtils.getShortestRotation(weaponFacing , targetFacing) + "", 20f ,new Color(100,100,100,100),s, 0.25f, 120f);
				allShipsInArc.add(s);
			}
		}

		float closestDist = 4000f;
		CombatEntityAPI closestShip = null;
		for (CombatEntityAPI c : allShipsInArc) {
			if (MathUtils.getDistance(c, from.getShip()) < closestDist) {
				closestDist = MathUtils.getDistance(c, from.getShip());
				closestShip = c;
			}
		}

		if (closestShip == null) {
			return null;
		}
		ShipAPI ship = (ShipAPI) closestShip;
		if (!ship.isAlly() && ship.getOwner() != 0) {
			return ship;
		} else {
			return null;
		}
	}

	public static void aimToPoint(WeaponAPI weapon, Vector2f toTargetPo) {
		ShipAPI ship = weapon.getShip();
		Vector2f angle = VectorUtils.getDirectionalVector(weapon.getLocation(), toTargetPo);
		float angleFacing = VectorUtils.getFacing(angle);
		float maxTurnRate = weapon.getTurnRate() / 60f;
		float angleDist = MathUtils.getShortestRotation(weapon.getCurrAngle(), angleFacing);

		if (Math.abs(MathUtils.getShortestRotation(weapon.getSlot().getAngle() + ship.getFacing(), angleFacing)) > (weapon.getSlot().getArc() / 2)) {

		} else {
			if (angleDist >= 0) {
				if (angleDist > maxTurnRate) {
					weapon.setCurrAngle(weapon.getCurrAngle() + maxTurnRate);
				} else {
					weapon.setCurrAngle(angleFacing);
				}
			} else {
				if (angleDist < -maxTurnRate) {
					weapon.setCurrAngle(weapon.getCurrAngle() - maxTurnRate);
				} else {
					weapon.setCurrAngle(angleFacing);
				}
			}
		}

	}

	//by seconds
	public static float projTimeToHitShip(CombatEntityAPI proj, CombatEntityAPI ship) {
		float projFlyRange = 1600f;
		Vector2f projEnd = proj.getLocation();
		if (proj instanceof MissileAPI && ((MissileAPI) proj).isGuided()) {
			projEnd = ship.getLocation();
		} else {
			projEnd = getExtendedLocationFromPoint(proj.getLocation(), VectorUtils.getFacing(proj.getVelocity()), projFlyRange);
		}
		Vector2f hitPoint = CollisionUtils.getCollisionPoint(proj.getLocation(), projEnd, ship);
		if (hitPoint == null) {
			return 1000f;
		} else {
			return (MathUtils.getDistance(proj.getLocation(), hitPoint) / Velocity2Speed(proj.getVelocity()).y);
		}
	}

	public static void returnToParent(ShipAPI ship, ShipAPI parentShip, float amount) {
		ship.giveCommand(ShipCommand.HOLD_FIRE, null, 0);
		String id = "returnToParent";

		if (parentShip.getLaunchBaysCopy().size() <= 0) {
			Color callBackColor = (ship.getShield() != null ? ship.getShield().getInnerColor() : new Color(100, 100, 200, 100));
			Global.getCombatEngine().spawnExplosion(ship.getLocation(), //loc
					new Vector2f(0f, 0f), //velocity
					callBackColor, //color
					ship.getCollisionRadius() * 3f, //range
					0.5f);//duration
			Global.getCombatEngine().removeEntity(ship);
		}

		//landing check
		boolean landingStarted = false;
		if (ship.isLanding()) {
			landingStarted = true;
		}

		Vector2f toTargetPo = ship.getWing().getSource().getLandingLocation(ship);
		float dist = MathUtils.getDistance(ship.getLocation(), toTargetPo);

		if (dist > 100f) {
			GDLMTool.moveToPosition(ship, toTargetPo, amount);
			if (landingStarted) {
				ship.abortLanding();
			}
		} else {
			ship.getMutableStats().getMaxSpeed().modifyFlat(id, parentShip.getMaxSpeed() + ship.getMaxSpeed());
			GDLMTool.moveToAngle(ship, parentShip.getFacing(), amount);
			GDLMTool.setToPosition(ship, toTargetPo, amount);
		}

		if (dist <= 50f) {

			if (!landingStarted) {
				ship.beginLandingAnimation(parentShip);
				ship.getMutableStats().getMaxSpeed().modifyFlat(id, parentShip.getMaxSpeed() + ship.getMaxSpeed());
			}

		}

		if (ship.isFinishedLanding()) {
			ship.getWing().getSource().land(ship);
		}

	}

	//x is angle,y is dist
	public static Vector2f getRelativeLocationData(Vector2f hitPoint, CombatEntityAPI target, boolean relativeToShield) {
		float absoluteAngle = VectorUtils.getAngle(target.getLocation(), hitPoint);
		float angle = 0f;
		if (relativeToShield) {
			angle = GDLMTool.getAngleCalculation(absoluteAngle, -target.getShield().getFacing());
		} else {
			angle = GDLMTool.getAngleCalculation(absoluteAngle, -target.getFacing());
		}
		float dist = MathUtils.getDistance(target.getLocation(), hitPoint);
		return new Vector2f(angle, dist);
	}

	public static Vector2f getAbsoluteLocation(float angle, float dist, CombatEntityAPI target, boolean relativeToShield) {
		if (relativeToShield) {
			float absoluteAngle = GDLMTool.getAngleCalculation(angle, target.getShield().getFacing());
			return GDLMTool.getExtendedLocationFromPoint(target.getLocation(), absoluteAngle, dist);
		} else {
			float absoluteAngle = GDLMTool.getAngleCalculation(angle, target.getFacing());
			return GDLMTool.getExtendedLocationFromPoint(target.getLocation(), absoluteAngle, dist);
		}
	}

	public static Vector2f getAbsoluteLocation(Vector2f relativeData, CombatEntityAPI target, boolean relativeToShield) {
		float angle = relativeData.x;
		float dist = relativeData.y;

		if (relativeToShield) {
			float absoluteAngle = GDLMTool.getAngleCalculation(angle, target.getShield().getFacing());
			return GDLMTool.getExtendedLocationFromPoint(target.getLocation(), absoluteAngle, dist);
		} else {
			float absoluteAngle = GDLMTool.getAngleCalculation(angle, target.getFacing());
			return GDLMTool.getExtendedLocationFromPoint(target.getLocation(), absoluteAngle, dist);
		}
	}

	public static List<Vector2f> getWeaponOffsetInAbsoluteCoo(WeaponAPI w) {
		List<Vector2f> absCoo = new ArrayList();
		if (w.getSlot().isTurret()) {
			for (Vector2f offset : w.getSpec().getTurretFireOffsets()) {
				Vector2f absOffset = getExtendedLocationFromPoint(w.getLocation(), w.getCurrAngle(), offset.x);
				absOffset = getExtendedLocationFromPoint(absOffset, getAngleCalculation(w.getCurrAngle(), 90f), offset.y);
				absCoo.add(absOffset);
			}
		} else {
			for (Vector2f offset : w.getSpec().getHardpointFireOffsets()) {
				Vector2f absOffset = getExtendedLocationFromPoint(w.getLocation(), w.getCurrAngle(), offset.x);
				absOffset = getExtendedLocationFromPoint(absOffset, getAngleCalculation(w.getCurrAngle(), 90f), offset.y);
				absCoo.add(absOffset);
			}
		}
		return absCoo;
	}

	// +x = to top, -y = to right
	public static Vector2f getWeaponOffsetInAbsoluteCoo(Vector2f relativeCoo, WeaponAPI w) {

		Vector2f absOffset = getExtendedLocationFromPoint(w.getLocation(), w.getCurrAngle(), relativeCoo.x);
		absOffset = getExtendedLocationFromPoint(absOffset, getAngleCalculation(w.getCurrAngle(), 90f), relativeCoo.y);

		return absOffset;
	}

	public static float getDistForProjToHit(CombatEntityAPI proj, ShipAPI ship) {
		if (ship.getShield() == null) {
			return 1000;
		}

		boolean inAngle = false;
		if (Math.abs(MathUtils.getShortestRotation(VectorUtils.getAngle(ship.getLocation(), proj.getLocation()), ship.getShield().getFacing())) < ship.getShield().getActiveArc() / 2) {
			inAngle = true;
		}

		if (inAngle) {
			return MathUtils.getDistance(proj.getLocation(), ship.getLocation()) - ship.getShield().getRadius();
		} else {
			return 1000;
		}
	}

	public static float limitToTop(float input, float limit) {
		if (input > limit) {
			return limit;
		}
		return input;
	}

	public static float limitToTop(float input, float limitMax, float limitMin) {
		if (input > limitMax) {
			return limitMax;
		}
		if (input < limitMin) {
			return limitMin;
		}
		return input;
	}

	public static float getFirstDecimal(float input) {
		String input2string = Float.toString(input);
		String[] allString = input2string.split("\\.");
		return Float.parseFloat(allString[1]);
	}

	public static CargoAPI getPlayerCargo() {
		return Global.getSector().getPlayerFleet().getCargo();
	}

	public static boolean checkCargoAvailable(CombatEngineAPI engine, ShipAPI ship) {
		if (engine == null) {
			if (ship != null && ship.getOwner() == 0) {
				return true;
			}

			if (ship == null) {
				if (Global.getSector().getPlayerFleet() != null) {
					return true;
				}
			}

		} else {
			if (engine.isInCampaign() && !engine.isInCampaignSim() && ship != null && ship.getOwner() == 0) {
				return true;
			}
		}

		return false;

	}

	public static void killMissile(MissileAPI missile, CombatEngineAPI engine) {

		engine.applyDamage(missile,//target
				missile.getLocation(),//point
				missile.getHitpoints() + 10f,//damge
				DamageType.FRAGMENTATION, 0f, true,//deal softflux
				true,//is bypass shield
				missile);//damage source
	}

	public static ShipAPI getNearestFriendCombatShip(CombatEntityAPI e) {
		float distMost = 1000000f;
		ShipAPI returnShip = null;
		for (ShipAPI s : AIUtils.getAlliesOnMap(e)) {
			if (s.isFrigate() || s.isDestroyer() || s.isCruiser() || s.isCapital()) {
				float dist = MathUtils.getDistance(e, s);
				if (dist < distMost) {
					returnShip = s;
					distMost = dist;
				}
			}
		}
		return returnShip;
	}

	public static boolean isNormalWeaponSlotType(WeaponSlotAPI slot, boolean containMissile) {

		if (slot.getWeaponType() != WeaponAPI.WeaponType.DECORATIVE && slot.getWeaponType() != WeaponAPI.WeaponType.BUILT_IN && slot.getWeaponType() != WeaponAPI.WeaponType.LAUNCH_BAY && slot.getWeaponType() != WeaponAPI.WeaponType.SYSTEM && slot.getWeaponType() != WeaponAPI.WeaponType.STATION_MODULE) {
			if (containMissile) {
				return true;
			} else {
				if (slot.getWeaponType() != WeaponAPI.WeaponType.MISSILE) {
					return true;
				}
			}

		}
		return false;
	}

	public static boolean isNormalWeaponType(WeaponAPI w, boolean containMissile) {

		if (w.getType() != WeaponAPI.WeaponType.DECORATIVE && w.getType() != WeaponAPI.WeaponType.BUILT_IN && w.getType() != WeaponAPI.WeaponType.LAUNCH_BAY && w.getType() != WeaponAPI.WeaponType.SYSTEM && w.getType() != WeaponAPI.WeaponType.STATION_MODULE) {
			if (containMissile) {
				return true;
			} else {
				if (w.getType() == WeaponAPI.WeaponType.MISSILE) {
					return false;
				} else {
					return true;
				}
			}

		}
		return false;
	}

	public static Vector2f getRandomPointAround(Vector2f center, float range) {
		float angle = MathUtils.getRandomNumberInRange(0, 360);
		float dist = MathUtils.getRandomNumberInRange(0, range);
		return GDLMTool.getExtendedLocationFromPoint(center, angle, dist);
	}

	public static float getOutOfRangeWeaponCostPercent(WeaponGroupAPI group, Vector2f toTargetPo, float rangeFix) {
		if (group == null) {
			return 1;
		}

		float allCost = 0.01f;
		float ableToFireCost = 0.01f;
		for (WeaponAPI w : group.getWeaponsCopy()) {
			if (Math.abs(w.distanceFromArc(toTargetPo)) == 0 && GDLMTool.isNormalWeaponSlotType(w.getSlot(), false)) {
				allCost = allCost + w.getSpec().getOrdnancePointCost(null, null);
				if (MathUtils.getDistance(w.getLocation(), toTargetPo) > w.getRange() - rangeFix) {
					ableToFireCost = ableToFireCost + w.getSpec().getOrdnancePointCost(null, null);
				}
			}
		}

		return GDLMTool.limitToTop(ableToFireCost / allCost, 1f, 0f);

	}

	public static void toggleSystemControl(ShipAPI systemShip, boolean shouldUse) {
		if (shouldUse && !systemShip.getSystem().isActive()) {
			systemShip.useSystem();
		}
		if (!shouldUse && (systemShip.getSystem().getState() == ShipSystemAPI.SystemState.IN || systemShip.getSystem().getState() == ShipSystemAPI.SystemState.ACTIVE)) {
			systemShip.useSystem();
		}
	}

}
