package data.scripts.weapons;

import com.fs.starfarer.api.combat.EveryFrameWeaponEffectPlugin;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.WeaponAPI;
import com.fs.starfarer.api.combat.DamageType;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.BeamAPI;
import com.fs.starfarer.api.combat.ArmorGridAPI;

public class EnergyDamageEffect implements EveryFrameWeaponEffectPlugin {

	@Override
	public void advance(float amount, CombatEngineAPI engine, WeaponAPI weapon) {
		if (weapon.isFiring()) {
			for (BeamAPI beam : engine.getBeams()) {
				if (beam.getWeapon() == weapon && beam.didDamageThisFrame() && beam.getDamageTarget() instanceof ShipAPI) {
					ShipAPI target = (ShipAPI) beam.getDamageTarget();
					ArmorGridAPI armor = target.getArmorGrid();
					int cell[] = armor.getCellAtLocation(beam.getTo());
					if (cell != null) {
						float armorV = armor.getArmorValue(cell[0], cell[1]);
						if (armorV < 0.01f) {
							engine.applyDamage(beam.getDamageTarget(), beam.getTo(), 200f * amount, DamageType.ENERGY, 0f, false, true, weapon.getShip());
							ShipAPI ship = weapon.getShip();

						}
					}
				}
			}
		}
	}
}